svn commit: r188990 - projects/stress2/misc

Peter Holm pho at FreeBSD.org
Tue Feb 24 00:15:45 PST 2009


Author: pho
Date: Tue Feb 24 08:15:44 2009
New Revision: 188990
URL: http://svn.freebsd.org/changeset/base/188990

Log:
  Tests of unmount of a device that is already gone
  
  Approved by:	kib

Added:
  projects/stress2/misc/backingstore2.sh   (contents, props changed)
  projects/stress2/misc/backingstore3.sh   (contents, props changed)

Added: projects/stress2/misc/backingstore2.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/backingstore2.sh	Tue Feb 24 08:15:44 2009	(r188990)
@@ -0,0 +1,73 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test unmount of a device that is already gone
+
+# Leaves /mnt6 unmountable and leads to a "panic: 1 vncache entries remaining"
+# during shut down.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+D=$diskimage
+export here=`pwd`
+
+m1=$mdstart
+m2=$((m1 + 1))
+mount | grep "${mntpoint}" | grep -q md$m2 && umount ${mntpoint}$m2
+mdconfig -l | grep -q md$m2 &&  mdconfig -d -u $m2
+mount | grep "${mntpoint}" | grep -q md$m1 && umount ${mntpoint}$m1
+mdconfig -l | grep -q md$m1 &&  mdconfig -d -u $m1
+
+dede $D$m1 100m 1 || exit 1
+
+mdconfig -a -t vnode -f $D$m1 -u $m1
+
+bsdlabel -w md$m1 auto
+newfs md${m1}${part} > /dev/null 2>&1
+mount /dev/md${m1}${part} ${mntpoint}$m1
+
+
+truncate -s 500M ${mntpoint}$m1/diskimage
+mdconfig -a -t vnode -f ${mntpoint}$m1/diskimage -u $m2
+
+bsdlabel -w md$m2 auto
+newfs md${m2}${part} > /dev/null 2>&1
+mount /dev/md${m2}${part} ${mntpoint}$m2
+
+# Reversed umount sequence:
+umount -f /dev/md${m1}${part}
+umount -f /dev/md${m2}${part}
+
+mount | grep "${mntpoint}" | grep -q md$m2 && umount ${mntpoint}$m2
+mdconfig -l | grep -q md$m2 &&  mdconfig -d -u $m2
+mount | grep "${mntpoint}" | grep -q md$m1 && umount ${mntpoint}$m1
+mdconfig -l | grep -q md$m1 &&  mdconfig -d -u $m1

Added: projects/stress2/misc/backingstore3.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/backingstore3.sh	Tue Feb 24 08:15:44 2009	(r188990)
@@ -0,0 +1,74 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test unmount of a device that is already gone
+
+# Caused "panic: bundirty: buffer 0xdafaf2c4 still on queue 1"
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+D=$diskimage
+export here=`pwd`
+
+m1=$mdstart
+m2=$((m1 + 1))
+mount | grep "${mntpoint}" | grep -q md$m2 && umount ${mntpoint}$m2
+mdconfig -l | grep -q md$m2 &&  mdconfig -d -u $m2
+mount | grep "${mntpoint}" | grep -q md$m1 && umount ${mntpoint}$m1
+mdconfig -l | grep -q md$m1 &&  mdconfig -d -u $m1
+
+dede $D$m1 25m 1 || exit 1
+
+mdconfig -a -t vnode -f $D$m1 -u $m1
+
+bsdlabel -w md$m1 auto
+newfs md${m1}${part} > /dev/null 2>&1
+mount /dev/md${m1}${part} ${mntpoint}$m1
+
+
+truncate -s 500M ${mntpoint}$m1/diskimage
+mdconfig -a -t vnode -f ${mntpoint}$m1/diskimage -u $m2
+
+bsdlabel -w md$m2 auto
+newfs md${m2}${part} > /dev/null 2>&1
+mount /dev/md${m2}${part} ${mntpoint}$m2
+
+dd if=/dev/zero of=${mntpoint}$m2/file bs=1m > /dev/null 2>&1
+
+# Reversed umount sequence:
+umount -f /dev/md${m1}${part}
+umount -f /dev/md${m2}${part}
+
+mount | grep "${mntpoint}" | grep -q md$m2 && umount ${mntpoint}$m2
+mdconfig -l | grep -q md$m2 &&  mdconfig -d -u $m2
+mount | grep "${mntpoint}" | grep -q md$m1 && umount ${mntpoint}$m1
+mdconfig -l | grep -q md$m1 &&  mdconfig -d -u $m1


More information about the svn-src-projects mailing list